﻿using Microsoft.Office.Interop.Outlook;
using System;

namespace TestProject
{
    /// <summary>
    /// 커스텀 애드인
    /// </summary>
    public partial class CustomAddIn
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 폴더 컨테이너 관리자
        /// </summary>
        private FolderContainerManager folderContainerManager = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 커스텀 애드인 시작시 처리하기 - CustomAddIn_Startup(sender, e)

        /// <summary>
        /// 커스텀 애드인 시작시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Startup(object sender, EventArgs e)
        {
            Application.Session.CreatSalesForceFolders();

            this.folderContainerManager = new FolderContainerManager(Application.Session);

            this.folderContainerManager.FolderRemove += folderContainerManager_FolderRemove;

            this.folderContainerManager.BuildFolderContainerDictionary();

            (Application as ApplicationEvents_11_Event).Quit += application_Quit;
        }

        #endregion
        #region 커스텀 애드인 셧다운시 처리하기 - CustomAddIn_Shutdown(sender, e)

        /// <summary>
        /// 커스텀 애드인 셧다운시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Shutdown(object sender, EventArgs e)
        {
        }

        #endregion

        #region 애플리케이션 종료시 처리하기 - application_Quit()

        /// <summary>
        /// 애플리케이션 종료시 처리하기
        /// </summary>
        private void application_Quit()
        {
            this.folderContainerManager.Dispose();

            this.folderContainerManager = null;
        }

        #endregion

        #region 폴더 컨테이너 관리자 폴더 삭제시 처리하기 - folderContainerManager_FolderRemove(sender, e)

        /// <summary>
        /// 폴더 컨테이너 관리자 폴더 삭제시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void folderContainerManager_FolderRemove(object sender, EventArgs e)
        {
            System.Windows.Forms.MessageBox.Show("폴더가 삭제되었습니다.");
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region VSTO에서 생성한 코드

        /// <summary>
        /// 디자이너 지원에 필요한 메서드입니다. 
        /// 이 메서드의 내용을 코드 편집기로 수정하지 마세요.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup  += new System.EventHandler(CustomAddIn_Startup );
            this.Shutdown += new System.EventHandler(CustomAddIn_Shutdown);
        }

        #endregion
    }
}